Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# ButtonThrower Class Reference

Throws Panda Events for button down/up events generated within the data graph. More...

Inheritance diagram for ButtonThrower:

List of all members.

## Public Member Functions
| ButtonThrower (string name)
| addParameter (EventParameter const obj)
| Adds the indicated parameter to the list of parameters that will be passed with each event generated by this ButtonThrower.
bool | addThrowButton (ModifierButtons const mods, ButtonHandle const button)
| Adds a new button to the set of buttons that the ButtonThrower explicitly processes.
| clearThrowButtons ()
| Empties the set of buttons that were added via add_throw_button().
string | getButtonDownEvent ()
| Returns the button_down_event that has been set on this ButtonThrower.
string | getButtonRepeatEvent ()
| Returns the button_repeat_event that has been set on this ButtonThrower.
string | getButtonUpEvent ()
| Returns the button_up_event that has been set on this ButtonThrower.
string | getCandidateEvent ()
| Returns the candidate_event that has been set on this ButtonThrower.
string | getKeystrokeEvent ()
| Returns the keystroke_event that has been set on this ButtonThrower.
ModifierButtons const | getModifierButtons ()
| Returns the set of ModifierButtons that the ButtonThrower will consider important enough to prepend the event name with.
string | getMoveEvent ()
| Returns the move_event that has been set on this ButtonThrower.
int | getNumParameters ()
| Returns the number of parameters that have been added to the list of parameters to be passed with each event generated by this ButtonThrower.
EventParameter | getParameter (int n)
| Returns the nth parameter that has been added to the list of parameters passed with each event generated by this ButtonThrower.
list | getParameters ()
string | getPrefix ()
| Returns the prefix that has been set on this ButtonThrower.
bool | getSpecificFlag ()
| Returns the flag that indicates whether specific events should be generated.
bool | getThrowButtonsActive ()
| Returns the flag that indicates whether the ButtonThrower will only process events for the explicitly named buttons or not.
bool | getTimeFlag ()
| Returns the flag that indicates whether the time of the button event should be passed as a parameter.
bool | hasThrowButton (ModifierButtons const mods, ButtonHandle const button)
| Returns true if the indicated button is on the set of buttons that will be processed by the ButtonThrower, false otherwise.
bool | hasThrowButton (ButtonHandle const button)
| Returns true if the indicated button, in conjunction with any nonspecified modifier buttons, is on the set of buttons that will be processed by the ButtonThrower.
bool | removeThrowButton (ModifierButtons const mods, ButtonHandle const button)
| Removes the indicated button from the set of buttons that the ButtonThrower explicitly processes.
| setButtonDownEvent (string button_down_event)
| Specifies the generic event that is generated (if any) each time a key or button is depressed.
| setButtonRepeatEvent (string button_repeat_event)
| Specifies the generic event that is generated (if any) repeatedly while a key or button is held down.
| setButtonUpEvent (string button_up_event)
| Specifies the generic event that is generated (if any) each time a key or button is released.
| setCandidateEvent (string candidate_event)
| Specifies the event that is generated (if any) for each IME candidate string event received.
| setKeystrokeEvent (string keystroke_event)
| Specifies the event that is generated (if any) for each keystroke that is received.
| setModifierButtons (ModifierButtons const mods)
| Changes the set of ModifierButtons that the ButtonThrower will consider important enough to prepend the event name with.
| setMoveEvent (string move_event)
| Specifies the event that is generated (if any) each time the mouse is moved within the window.
| setPrefix (string prefix)
| Sets the prefix which is prepended to all specific event names (that is, event names generated from the button name itself, as opposed to the generic event names like set_button_down_event) thrown by this object.
| setSpecificFlag (bool specific_flag)
| Sets the flag that indicates whether specific events (events prefixed by set_prefix, and based on the event name) should be generated at all.
| setThrowButtonsActive (bool flag)
| Sets the flag that indicates whether the ButtonThrower will only process events for the explicitly named buttons or not.
| setTimeFlag (bool time_flag)
| Sets the flag that indicates whether the time of the button event should be passed as a parameter or not.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

Throws Panda Events for button down/up events generated within the data graph.

This is a DataNode which is intended to be parented to the data graph below a device which is generating a sequence of button events, like a MouseAndKeyboard device. It simply takes each button it finds and throws a corresponding event based on the button name via the throw_event() call.

## Constructor & Destructor Documentation

ButtonThrower | ( | string | name | ) |

## Member Function Documentation

addParameter | ( | EventParameter const | obj | ) |

Adds the indicated parameter to the list of parameters that will be passed with each event generated by this ButtonThrower.

bool addThrowButton | ( | ModifierButtons const | mods,
|  | ButtonHandle const | button
| ) |  |

Adds a new button to the set of buttons that the ButtonThrower explicitly processes.

If set_throw_buttons_active is false (which is the default), the ButtonThrower will process all buttons. Otherwise, the ButtonThrower will only process events for the button(s) explicitly named by this function; buttons not on the list will be ignored by this object and passed on downstream to the child node(s) in the data graph. A button that *is* on the list will be processed by the ButtonThrower and not passed on to the child node(s).

The return value is true if the button is added, or false if it was already in the set.

clearThrowButtons | ( |  | ) |

Empties the set of buttons that were added via add_throw_button().

See add_throw_button().

string getButtonDownEvent | ( |  | ) |

Returns the button_down_event that has been set on this ButtonThrower.

See set_button_down_event().

string getButtonRepeatEvent | ( |  | ) |

Returns the button_repeat_event that has been set on this ButtonThrower.

See set_button_repeat_event().

string getButtonUpEvent | ( |  | ) |

Returns the button_up_event that has been set on this ButtonThrower.

See set_button_up_event().

string getCandidateEvent | ( |  | ) |

Returns the candidate_event that has been set on this ButtonThrower.

See set_candidate_event().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from DataNode.

string getKeystrokeEvent | ( |  | ) |

Returns the keystroke_event that has been set on this ButtonThrower.

See set_keystroke_event().

ModifierButtons const getModifierButtons | ( |  | ) |

Returns the set of ModifierButtons that the ButtonThrower will consider important enough to prepend the event name with.

Normally, this set will be empty, and the ButtonThrower will therefore ignore all ModifierButtons attached to the key events, but if one or more buttons have been added to this set, and those modifier buttons are set on the button event, then the event name will be prepended with the names of the modifier buttons.

string getMoveEvent | ( |  | ) |

Returns the move_event that has been set on this ButtonThrower.

See set_move_event().

int getNumParameters | ( |  | ) |

Returns the number of parameters that have been added to the list of parameters to be passed with each event generated by this ButtonThrower.

EventParameter getParameter | ( | int | n | ) |

Returns the nth parameter that has been added to the list of parameters passed with each event generated by this ButtonThrower.

list getParameters | ( |  | ) |

string getPrefix | ( |  | ) |

Returns the prefix that has been set on this ButtonThrower.

See set_prefix().

bool getSpecificFlag | ( |  | ) |

Returns the flag that indicates whether specific events should be generated.

See set_specific_flag().

bool getThrowButtonsActive | ( |  | ) |

Returns the flag that indicates whether the ButtonThrower will only process events for the explicitly named buttons or not.

See set_throw_buttons_active().

bool getTimeFlag | ( |  | ) |

Returns the flag that indicates whether the time of the button event should be passed as a parameter.

bool hasThrowButton | ( | ButtonHandle const | button | ) |

Returns true if the indicated button, in conjunction with any nonspecified modifier buttons, is on the set of buttons that will be processed by the ButtonThrower.

That is to say, returns true if this button was ever passed as the second parameter add_throw_button(), regardless of what the first parameter was.

bool hasThrowButton | ( | ModifierButtons const | mods,
|  | ButtonHandle const | button
| ) |  |

Returns true if the indicated button is on the set of buttons that will be processed by the ButtonThrower, false otherwise.

See add_throw_button().

bool removeThrowButton | ( | ModifierButtons const | mods,
|  | ButtonHandle const | button
| ) |  |

Removes the indicated button from the set of buttons that the ButtonThrower explicitly processes.

See add_throw_button().

The return value is true if the button is removed, or false if it was not on the set.

setButtonDownEvent | ( | string | button_down_event | ) |

Specifies the generic event that is generated (if any) each time a key or button is depressed.

Unlike the specific events that are unique to each key, this same event name is used for *all* button events, and the name of the button pressed (possibly with modifier prefixes) will be sent as a parameter.

If this string is empty, no event is generated. It is possible to generate both generic events and specific events for the same button.

See also set_keystroke_event().

setButtonRepeatEvent | ( | string | button_repeat_event | ) |

Specifies the generic event that is generated (if any) repeatedly while a key or button is held down.

Unlike the specific events that are unique to each key, this same event name is used for *all* button events, and the name of the button pressed (possibly with modifier prefixes) will be sent as a parameter.

If this string is empty, no event is generated. It is possible to generate both generic events and specific events for the same button.

See also set_keystroke_event().

setButtonUpEvent | ( | string | button_up_event | ) |

Specifies the generic event that is generated (if any) each time a key or button is released.

See set_button_down_event().

setCandidateEvent | ( | string | candidate_event | ) |

Specifies the event that is generated (if any) for each IME candidate string event received.

Events of this nature are received only when the user is entering data using a Microsoft Input Method Editor, typically used for Asian languages such as Japanese or Korean.

If you are designing a typing user interface, you should track this event to support the use of the IME. In response to this event, you should display the candidate string in the entry box, with the appropriate sections highlighted, so the user can scroll through the available choices.

This event is generated with four parameters, in order: the candidate string, the character at which to start the highlight, the character at which to end the highlight, and the current cursor position.

setKeystrokeEvent | ( | string | keystroke_event | ) |

Specifies the event that is generated (if any) for each keystroke that is received.

A keystroke is different than a button event: it represents the semantic meaning of the sequence of keys that have been pressed. For instance, pressing shift and 4 together will generate the button event "shift-4", but it will generate the keystroke "$".

If a key is held down, keyrepeat will cause the same keystroke event to be generated repeatedly. This is different from the corresponding down event, which will only be generated once, followed by a number of button repeat events.

This event is generated with a single wstring parameter, which is a one-character string that contains the keystroke generated. If this event string is empty, no event is generated.

See also set_button_down_event().

setModifierButtons | ( | ModifierButtons const | mods | ) |

Changes the set of ModifierButtons that the ButtonThrower will consider important enough to prepend the event name with.

Normally, this set will be empty, and the ButtonThrower will therefore ignore all ModifierButtons attached to the key events, but if one or more buttons have been added to this set, then the event name will be prepended with the names of the modifier buttons.

It is recommended that you change this setting by first calling get_modifier_buttons(), making adjustments, and passing the new value to set_modifier_buttons(). This way the current state of the modifier buttons will not be lost.

setMoveEvent | ( | string | move_event | ) |

Specifies the event that is generated (if any) each time the mouse is moved within the window.

setPrefix | ( | string | prefix | ) |

Sets the prefix which is prepended to all specific event names (that is, event names generated from the button name itself, as opposed to the generic event names like set_button_down_event) thrown by this object.

setSpecificFlag | ( | bool | specific_flag | ) |

Sets the flag that indicates whether specific events (events prefixed by set_prefix, and based on the event name) should be generated at all.

This is true by default, but may be disabled if you are only interested in the generic events (for instance, events like set_button_down_event).

setThrowButtonsActive | ( | bool | flag | ) |

Sets the flag that indicates whether the ButtonThrower will only process events for the explicitly named buttons or not.

Normally this is false, meaning all buttons are processed; set it true to indicate that only some buttons should be processed. See add_throw_button().

setTimeFlag | ( | bool | time_flag | ) |

Sets the flag that indicates whether the time of the button event should be passed as a parameter or not.

When this is true, an additional parameter is generated on each event (before all the parameters named by add_parameter) that consists of a single double value, and reflects the time the button was pressed or released, as a value from ClockObject.get_global_clock().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties